#include<bits/stdc++.h>
using namespace std;
string str1, str2;
int niz[200050];
int mini;
int n,k;
char pos;
int main ()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cin >> n >> k;
    cin >> str1;
    str2 = str1;
    sort(str2.begin(), str2.end());
    if(str1 == str2)
    {
        pos = str2[str2.size()-1];
        for(int i = 0; i<str1.size(); i++)
        {
            if(str2[i] == pos)
                cout << "2 ";
            else
                cout << "1 ";
        }
        cout << "\n";
        return 0;
    }
    else
    {
        for(int i=0; i<str1.size(); i++)
        {
            niz[int(str1[i]) - 96]++;
            mini = 200050;
            for(int j = 1; j<=k; j++)
                mini = min(mini, niz[j]);
            cout << mini+1 << " ";
        }
        cout << "\n";
    }
    return 0;
}